/*
Copyright (c) Daybrush
name: vue-infinite-viewer
license: MIT
author: Daybrush
repository: https://github.com/daybrush/infinite-viewer/blob/master/packages/vue-infinite-viewer
version: 0.2.2-rc
*/
import VanillaInfiniteViewer, { CLASS_NAME, OPTIONS, EVENTS, PROPERTIES, METHODS } from 'infinite-viewer';
import { Component, Prop, Vue } from 'vue-property-decorator';
import { withMethods, Properties } from 'framework-utils';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

/* global Reflect, Promise */
var extendStatics = function (d, b) {
  extendStatics = Object.setPrototypeOf || {
    __proto__: []
  } instanceof Array && function (d, b) {
    d.__proto__ = b;
  } || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
  };

  return extendStatics(d, b);
};

function __extends(d, b) {
  extendStatics(d, b);

  function __() {
    this.constructor = d;
  }

  d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}
var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};
function __decorate(decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
}

var VueInfiniteViewer =
/*#__PURE__*/
function (_super) {
  __extends(VueInfiniteViewer, _super);

  function VueInfiniteViewer() {
    return _super !== null && _super.apply(this, arguments) || this;
  }

  var __proto = VueInfiniteViewer.prototype;

  __proto.render = function (h) {
    var props = this.$props;
    return h('div', {
      class: (props.className || '') + " " + CLASS_NAME,
      ref: 'container'
    }, [h('div', {
      ref: 'scrollArea'
    }), this.$slots.default]);
  };

  __proto.mounted = function () {
    var _this = this;

    var options = {};
    var props = this.$props;
    OPTIONS.forEach(function (name) {
      var value = props[name];

      if (value != null) {
        options[name] = props[name];
      }
    });
    var refs = this.$refs;
    this.infiniteViewer = new VanillaInfiniteViewer(refs.container, refs.scrollArea.nextElementSibling, __assign(__assign({}, options), {
      scrollArea: refs.scrollArea
    }));
    var infiniteViewer = this.infiniteViewer;
    EVENTS.forEach(function (name, i) {
      infiniteViewer.on(name, function (e) {
        _this.$emit(name, __assign({}, e));
      });
    });
  };

  __proto.updated = function () {
    var props = this.$props;
    var infiniteViewer = this.infiniteViewer;
    PROPERTIES.forEach(function (name) {
      if (name in props && infiniteViewer[name] !== props[name]) {
        infiniteViewer[name] = props[name];
      }
    });
  };

  __proto.beforeDestroy = function () {
    this.infiniteViewer.destroy();
  };

  __decorate([withMethods(METHODS)], VueInfiniteViewer.prototype, "infiniteViewer", void 0);

  VueInfiniteViewer = __decorate([Component({}), Properties(OPTIONS, function (prototype, name) {
    Prop()(prototype, name);
  })], VueInfiniteViewer);
  return VueInfiniteViewer;
}(Vue);

export { VueInfiniteViewer };
//# sourceMappingURL=infinite-viewer.esm.js.map
